<?

/*
	Document manager handling for users in LDAP
		Created by Will LaSala (will@dahome.org)
		February 10th, 2002
		Belenos INC
		For use with the DocMgr PHP scripts

	arguments in docman.conf file are:
	$ldapServer="x.x.x.x";		This can be in Dotted Notation or a DNS FQN
	$ldapServerPort="389";		This is the default port and doesnt need to be changed
	$basedn="o=CompanyName";	Branch of tree that your search will start on
	$bind="cn=Manager, o=CompanyName";	Login that allows password searching
	$bindpw="";			Password for the above account

	LDAP query must return login, password full_name and e-mail
	In order to do this it may be possible that you may need to modify a section of 
	the code below, however this is highly unlikly and usually only a person
	that has in-depth knowledge of thier LDAP tree structure will
	even know if they do have to make changes.
	The items that may need to changed are:
	$entries[0]["cn"][0];		This should return the Full Name
     	$entries[0]["userpassword"][0];	This should return the Password
     	$entries[0]["mail"][0];		This should return the Email	

	This file is included early in docman.php and it should return:
	$gblUserName	descriptive username
	$secHash	md5 hash of joint login and password
	$gblEmail	e-mail address of user

*/

if ($ds = ldap_connect_bind($bind, $bindpw, $ldapServer, $ldapServerPort)) {
 $sres = ldap_search($ds, $basedn, "uid=".$GLOBALS[gblLogin]);
 If ($sres) {
     $entries = ldap_get_entries($ds, $sres);
     $gblUserName = $entries[0]["cn"][0]; //Full Name
     // FIX : it should return md5, right (Dobrica)
     $secHash	  = $entries[0]["userpassword"][0]; //Password
     $gblEmail    = $entries[0]["mail"][0];  //Email
 }else{
     Error("Not Found","LDAP Search returned false");
 }
 ldap_close($ds);
}


function ldap_connect_bind($bindRDN, $bindpass, $ldapServer, $ldapServerPort) {
     $linkid = ldap_connect($ldapServer, $ldapServerPort);
     if ($linkid) {
       if (!ldap_bind($linkid, $bindRDN, $bindpass)) {
          Error("LDAP BIND","Unable to bind to LDAP server!");
          return 0;
       } else {
         return $linkid;
       }
     } else {
       Error("LDAP CONNECT","Unable to connect to LDAP server!");
       return 0;
     }
}
?>
